using AuthService.Data.Models;

namespace AuthService.Services.Interfaces; 

/// <summary>Service interface for email business logic.</summary>
public interface IEmailService {
    
    /// <summary>
    /// Sends an email containing the information a user needs to confirm their email.
    /// </summary>
    /// <param name="user">The user that signed up and will be receiving the email.</param>
    /// <param name="confirmTokenUrl">The confirmation token generated by the application.</param>
    void SendConfirmationEmail(AuthUser user, string confirmTokenUrl);

    /// <summary>
    /// Sends a notification to the user informing them that their password has been updated.
    /// </summary>
    /// <param name="userName">The username of the user whose password was changed.</param>
    /// <param name="email">The email address of the user whose password was changed.</param>
    void SendPasswordChangeNoticeEmail(string userName, string email);

    /// <summary>
    /// Sends a notification to the user informing them that their username was changed.
    /// </summary>
    /// <param name="originalUserName">The original username of the user whose username was changed.</param>
    /// <param name="updatedUserName">The updated username of the user whose username was changed.</param>
    /// <param name="email">The email address of the user whose username was changed.</param>
    void SendUsernameChangeNoticeEmail(string originalUserName, string updatedUserName, string email);

    /// <summary>
    /// Sends a message containing information on how to reset a user's password.
    /// </summary>
    /// <param name="userName">The username of the user that requested the password reset.</param>
    /// <param name="email">The email address of the user that requested the password reset.</param>
    /// <param name="resetTokenUrl">The reset token that was generated by the application.</param>
    void SendPasswordResetEmail(string? userName, string? email, string resetTokenUrl);

}